Skip to content

Add a spreadsheet editor in a popup, by using the Handsontable cell type.

The Handsontable cell type embeds a second grid instance as a cell editor (HOT-in-HOT). Use it when users need to search and select from a large dataset.

Usage

HOT-in-HOT opens by any of the following:

  • F2 or Enter key is pressed while the cell is selected
  • The triangle icon is clicked
  • The cell content is double clicked

While HOT-in-HOT is opened, the text field above the HOT-in-HOT remains focused at all times.

Basic example

JavaScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
// Register all Handsontable's modules.
registerAllModules();
const colorData = [['yellow'], ['red'], ['orange'], ['green'], ['blue'], ['gray'], ['black'], ['white']];
const manufacturerData = [
{ name: 'BMW', country: 'Germany', owner: 'Bayerische Motoren Werke AG' },
{ name: 'Chrysler', country: 'USA', owner: 'Chrysler Group LLC' },
{ name: 'Nissan', country: 'Japan', owner: 'Nissan Motor Company Ltd' },
{ name: 'Suzuki', country: 'Japan', owner: 'Suzuki Motor Corporation' },
{ name: 'Toyota', country: 'Japan', owner: 'Toyota Motor Corporation' },
{ name: 'Volvo', country: 'Sweden', owner: 'Zhejiang Geely Holding Group' },
];
const container = document.querySelector('#example1');
new Handsontable(container, {
height: 'auto',
licenseKey: 'non-commercial-and-evaluation',
data: [
['Tesla', 2017, 'black', 'black'],
['Nissan', 2018, 'blue', 'blue'],
['Chrysler', 2019, 'yellow', 'black'],
['Volvo', 2020, 'white', 'gray'],
],
colHeaders: ['Car', 'Year', 'Chassis color', 'Bumper color'],
columns: [
{
type: 'handsontable',
handsontable: {
colHeaders: ['Marque', 'Country', 'Parent company'],
autoColumnSize: true,
data: manufacturerData,
getValue() {
const selection = this.getSelectedLast();
// Get the manufacturer name of the clicked row and ignore header
// coordinates (negative values)
return this.getSourceDataAtRow(Math.max(selection[0], 0)).name;
},
},
},
{ type: 'numeric' },
{
type: 'handsontable',
handsontable: {
colHeaders: false,
data: colorData,
},
},
{
type: 'handsontable',
handsontable: {
colHeaders: false,
data: colorData,
},
},
],
autoWrapRow: true,
autoWrapCol: true,
});
TypeScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
// Register all Handsontable's modules.
registerAllModules();
interface Manufacturer {
name: string;
country: string;
owner: string;
}
const colorData: [string][] = [['yellow'], ['red'], ['orange'], ['green'], ['blue'], ['gray'], ['black'], ['white']];
const manufacturerData: Manufacturer[] = [
{ name: 'BMW', country: 'Germany', owner: 'Bayerische Motoren Werke AG' },
{ name: 'Chrysler', country: 'USA', owner: 'Chrysler Group LLC' },
{ name: 'Nissan', country: 'Japan', owner: 'Nissan Motor Company Ltd' },
{ name: 'Suzuki', country: 'Japan', owner: 'Suzuki Motor Corporation' },
{ name: 'Toyota', country: 'Japan', owner: 'Toyota Motor Corporation' },
{ name: 'Volvo', country: 'Sweden', owner: 'Zhejiang Geely Holding Group' },
];
const container = document.querySelector('#example1')!;
new Handsontable(container, {
height: 'auto',
licenseKey: 'non-commercial-and-evaluation',
data: [
['Tesla', 2017, 'black', 'black'],
['Nissan', 2018, 'blue', 'blue'],
['Chrysler', 2019, 'yellow', 'black'],
['Volvo', 2020, 'white', 'gray'],
],
colHeaders: ['Car', 'Year', 'Chassis color', 'Bumper color'],
columns: [
{
type: 'handsontable',
handsontable: {
colHeaders: ['Marque', 'Country', 'Parent company'],
autoColumnSize: true,
data: manufacturerData,
getValue() {
const selection = this.getSelectedLast();
// Get the manufacturer name of the clicked row and ignore header
// coordinates (negative values)
return this.getSourceDataAtRow(Math.max(selection[0], 0)).name;
},
},
},
{ type: 'numeric' },
{
type: 'handsontable',
handsontable: {
colHeaders: false,
data: colorData,
},
},
{
type: 'handsontable',
handsontable: {
colHeaders: false,
data: colorData,
},
},
],
autoWrapRow: true,
autoWrapCol: true,
});

Keyboard shortcuts

KeyAction
EscapeClose editor and cancel change
EnterClose editor and apply change; move selection in the main HOT downwards or according to the enterMoves setting
TabSame as Enter, but move selection to the right or left according to the tabMoves setting
Arrow DownMove selection in HOT-in-HOT downwards. No effect if last row is selected
Arrow UpMove selection in HOT-in-HOT upwards. If the first row was selected, deselect. If HOT-in-HOT was deselected, behave as Enter but move main HOT selection upwards
Arrow RightMove text cursor in the text field to the left. If cursor was at start, behave as Enter but move main HOT selection to the left
Arrow LeftMove text cursor in the text field to the right. If cursor was at end, behave as Tab

Result

After configuring the Handsontable cell type, cells display a text input with a trigger icon. Activating the cell opens a second embedded grid that users can navigate and select from. The selected row value is written back to the parent cell.

Related guides

Configuration options

Core methods

Hooks

React Data GridHandsontable cell type

Add a spreadsheet editor in a popup, by using the Handsontable cell type.

Usage

HOT-in-HOT opens by any of the following:

  • F2 or Enter key is pressed while the cell is selected
  • The triangle icon is clicked
  • The cell content is double clicked

While HOT-in-HOT is opened, the text field above the HOT-in-HOT remains focused at all times.

Keyboard bindings while the HOT-in-HOT is opened:

  • Escape - close editor and cancel change.
  • Enter - close editor and apply change*, move the selection in the main HOT downwards or according to the enterMoves setting.
  • Tab - behaves as the Enter key, but move the selection in the main HOT to the right or to the left (depending on your layoutDirection setting) or according to the tabMovessetting.
  • Arrow Down - move the selection in HOT-in-HOT downwards. If the last row was selected, this has no effect.
  • Arrow Up - move the selection in HOT-in-HOT upwards. If the first row was selected, deselect. If HOT-in-HOT was deselected, behave as the Enter key but move the selection in the main HOT upwards.
  • Arrow Right - move the text cursor in the text field to the left. If the text cursor was at the start position, behave as the Enter key but move the selection in the main HOT to the left.
  • Arrow Left - move the text cursor in the text field to the right. If the text cursor was at the end position, behave as the Tab key.

Basic example

import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

// register Handsontable's modules
registerAllModules();

const ExampleComponent = () => {
  const colorData = [['yellow'], ['red'], ['orange'], ['green'], ['blue'], ['gray'], ['black'], ['white']];
  const manufacturerData = [
    { name: 'BMW', country: 'Germany', owner: 'Bayerische Motoren Werke AG' },
    { name: 'Chrysler', country: 'USA', owner: 'Chrysler Group LLC' },
    { name: 'Nissan', country: 'Japan', owner: 'Nissan Motor Company Ltd' },
    { name: 'Suzuki', country: 'Japan', owner: 'Suzuki Motor Corporation' },
    { name: 'Toyota', country: 'Japan', owner: 'Toyota Motor Corporation' },
    { name: 'Volvo', country: 'Sweden', owner: 'Zhejiang Geely Holding Group' },
  ];

  return (
    <HotTable
      themeName="ht-theme-main"
      autoWrapRow={true}
      autoWrapCol={true}
      licenseKey="non-commercial-and-evaluation"
      data={[
        ['Tesla', 2017, 'black', 'black'],
        ['Nissan', 2018, 'blue', 'blue'],
        ['Chrysler', 2019, 'yellow', 'black'],
        ['Volvo', 2020, 'white', 'gray'],
      ]}
      colHeaders={['Car', 'Year', 'Chassis color', 'Bumper color']}
      columns={[
        {
          type: 'handsontable',
          handsontable: {
            colHeaders: ['Marque', 'Country', 'Parent company'],
            autoColumnSize: true,
            data: manufacturerData,
            getValue() {
              const selection = this.getSelectedLast();

              // Get the manufacturer name of the clicked row and ignore header
              // coordinates (negative values)
              return this.getSourceDataAtRow(Math.max(selection[0], 0)).name;
            },
          },
        },
        { type: 'numeric' },
        {
          type: 'handsontable',
          handsontable: {
            colHeaders: false,
            data: colorData,
          },
        },
        {
          type: 'handsontable',
          handsontable: {
            colHeaders: false,
            data: colorData,
          },
        },
      ]}
    />
  );
};

export default ExampleComponent;

Handsontable cell type
Add a spreadsheet editor in a popup, by using the Handsontable cell type.
The Handsontable cell type embeds a second grid instance as a cell editor (HOT-in-HOT). Use it when users need to search and select from a large dataset.
Usage
HOT-in-HOT opens by any of the following:
- F2 or Enter key is pressed while the cell is selected
- The triangle icon is clicked
- The cell content is double clicked
While HOT-in-HOT is opened, the text field above the HOT-in-HOT remains focused at all times.
Basic example
<script setup lang="ts">import { ref } from 'vue';import { HotTable } from '@handsontable/vue3';import { registerAllModules } from 'handsontable/registry';import type { GridSettings } from 'handsontable/settings';
// register Handsontable's modulesregisterAllModules();
const colorData = [['yellow'], ['red'], ['orange'], ['green'], ['blue'], ['gray'], ['black'], ['white']];
const manufacturerData = [ { name: 'BMW', country: 'Germany', owner: 'Bayerische Motoren Werke AG' }, { name: 'Chrysler', country: 'USA', owner: 'Chrysler Group LLC' }, { name: 'Nissan', country: 'Japan', owner: 'Nissan Motor Company Ltd' }, { name: 'Suzuki', country: 'Japan', owner: 'Suzuki Motor Corporation' }, { name: 'Toyota', country: 'Japan', owner: 'Toyota Motor Corporation' }, { name: 'Volvo', country: 'Sweden', owner: 'Zhejiang Geely Holding Group' },];
const hotSettings = ref<GridSettings>({ height: 'auto', autoWrapRow: true, autoWrapCol: true, data: [ ['Tesla', 2017, 'black', 'black'], ['Nissan', 2018, 'blue', 'blue'], ['Chrysler', 2019, 'yellow', 'black'], ['Volvo', 2020, 'white', 'gray'], ], colHeaders: ['Car', 'Year', 'Chassis color', 'Bumper color'], columns: [ { type: 'handsontable', handsontable: { colHeaders: ['Marque', 'Country', 'Parent company'], autoColumnSize: true, data: manufacturerData, getValue() { const selection = this.getSelectedLast();
// Get the manufacturer name of the clicked row and ignore header // coordinates (negative values) return this.getSourceDataAtRow(Math.max(selection[0], 0)).name; }, }, }, { type: 'numeric' }, { type: 'handsontable', handsontable: { colHeaders: false, data: colorData, }, }, { type: 'handsontable', handsontable: { colHeaders: false, data: colorData, }, }, ], licenseKey: 'non-commercial-and-evaluation',});</script>
<template> <div id="example1"> <HotTable :settings="hotSettings" /> </div></template>Keyboard shortcuts
| Key | Action |
|---|---|
| Escape | Close editor and cancel change |
| Enter | Close editor and apply change; move selection in the main HOT downwards or according to the enterMoves setting |
| Tab | Same as Enter, but move selection to the right or left according to the tabMoves setting |
| Arrow Down | Move selection in HOT-in-HOT downwards. No effect if last row is selected |
| Arrow Up | Move selection in HOT-in-HOT upwards. If the first row was selected, deselect. If HOT-in-HOT was deselected, behave as Enter but move main HOT selection upwards |
| Arrow Right | Move text cursor in the text field to the left. If cursor was at start, behave as Enter but move main HOT selection to the left |
| Arrow Left | Move text cursor in the text field to the right. If cursor was at end, behave as Tab |
Result
After configuring the Handsontable cell type, cells display a text input with a trigger icon. Activating the cell opens a second embedded grid that users can navigate and select from. The selected row value is written back to the parent cell.
Related articles
Related guides
Configuration options
Core methods
Hooks

Angular Data GridHandsontable cell type

Add a spreadsheet editor in a popup, by using the Handsontable cell type.

Usage

HOT-in-HOT opens by any of the following:

  • F2 or Enter key is pressed while the cell is selected
  • The triangle icon is clicked
  • The cell content is double clicked

While HOT-in-HOT is opened, the text field above the HOT-in-HOT remains focused at all times.

Keyboard bindings while the HOT-in-HOT is opened:

  • Escape - close editor and cancel change.
  • Enter - close editor and apply change*, move the selection in the main HOT downwards or according to the enterMoves setting.
  • Tab - behaves as the Enter key, but move the selection in the main HOT to the right or to the left (depending on your layoutDirection setting) or according to the tabMovessetting.
  • Arrow Down - move the selection in HOT-in-HOT downwards. If the last row was selected, this has no effect.
  • Arrow Up - move the selection in HOT-in-HOT upwards. If the first row was selected, deselect. If HOT-in-HOT was deselected, behave as the Enter key but move the selection in the main HOT upwards.
  • Arrow Right - move the text cursor in the text field to the left. If the text cursor was at the start position, behave as the Enter key but move the selection in the main HOT to the left.
  • Arrow Left - move the text cursor in the text field to the right. If the text cursor was at the end position, behave as the Tab key.

Basic example

/* file: app.component.ts */
import { Component } from '@angular/core';
import { GridSettings } from '@handsontable/angular-wrapper';

const colorData = [
  ['yellow'],
  ['red'],
  ['orange'],
  ['green'],
  ['blue'],
  ['gray'],
  ['black'],
  ['white'],
];

const manufacturerData = [
  { name: 'BMW', country: 'Germany', owner: 'Bayerische Motoren Werke AG' },
  { name: 'Chrysler', country: 'USA', owner: 'Chrysler Group LLC' },
  { name: 'Nissan', country: 'Japan', owner: 'Nissan Motor Company Ltd' },
  { name: 'Suzuki', country: 'Japan', owner: 'Suzuki Motor Corporation' },
  { name: 'Toyota', country: 'Japan', owner: 'Toyota Motor Corporation' },
  { name: 'Volvo', country: 'Sweden', owner: 'Zhejiang Geely Holding Group' },
];

@Component({
  selector: 'example1-handsontable-cell-type',
  standalone: false,
  template: ` <div>
    <hot-table [data]="data" [settings]="gridSettings"></hot-table>
  </div>`,
})
export class Example1HandsontableCellTypeComponent {

  readonly data = [
    ['Tesla', 2017, 'black', 'black'],
    ['Nissan', 2018, 'blue', 'blue'],
    ['Chrysler', 2019, 'yellow', 'black'],
    ['Volvo', 2020, 'white', 'gray'],
  ];

  readonly gridSettings: GridSettings = {
    colHeaders: ['Car', 'Year', 'Chassis color', 'Bumper color'],
    height: 'auto',
    autoWrapRow: true,
    autoWrapCol: true,
    columns: [
      {
        type: 'handsontable',
        handsontable: {
          colHeaders: ['Marque', 'Country', 'Parent company'],
          autoColumnSize: true,
          data: manufacturerData,
          getValue() {
            const selection = this.getSelectedLast();

            // Get the manufacturer name of the clicked row and ignore header
            // coordinates (negative values)
            return this.getSourceDataAtRow(Math.max(selection[0], 0)).name;
          },
        },
      },
      { type: 'numeric' },
      {
        type: 'handsontable',
        handsontable: {
          colHeaders: false,
          data: colorData,
        },
      },
      {
        type: 'handsontable',
        handsontable: {
          colHeaders: false,
          data: colorData,
        },
      },
    ]
  };
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
import { Example1HandsontableCellTypeComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ Example1HandsontableCellTypeComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ Example1HandsontableCellTypeComponent ]
})

export class AppModule { }